Minimum number of subsets with distinct elements
Last Updated :
13 Dec, 2023
You are given an array of n-element. You have to make subsets from the array such that no subset contain duplicate elements. Find out minimum number of subset possible.
Examples :
Input : arr[] = {1, 2, 3, 4}
Output :1
Explanation : A single subset can contains all
values and all values are distinct
Input : arr[] = {1, 2, 3, 3}
Output : 2
Explanation : We need to create two subsets
{1, 2, 3} and {3} [or {1, 3} and {2, 3}] such
that both subsets have distinct elements.
We basically need to find the most frequent element in the array. The result is equal to the frequency of the most frequent element. Since we have to create a subset such that each element in a subset is unique that means that all the repeating elements should be kept in a different set. Hence the maximum no subsites that we require is the frequency of the maximum time occurring element.
Ex -> { 1 , 2 , 1 , 2 , 3 , 3 , 2 , 2 }
here
Frequency of 1 -> 2
Frequency of 2 -> 4
Frequency of 3 -> 2
Since the frequency of 2 is maximum hence we need to have at least 4 subset to keep all the 2 in different subsets and rest of element can be occupied accordingly.
A simple solution is to run two nested loops to count frequency of every element and return the frequency of the most frequent element. Time complexity of this solution is O(n2).
A better solution is to first sort the array and then start count number of repetitions of elements in an iterative manner as all repetition of any number lie beside the number itself. By this method you can find the maximum frequency or repetition by simply traversing the sorted array. This approach will cost O(nlogn) time complexity
Implementation:
C++
#include <bits/stdc++.h>
using namespace std;
int subset( int ar[], int n)
{
int res = 0;
sort(ar, ar + n);
for ( int i = 0; i < n; i++) {
int count = 1;
for (; i < n - 1; i++) {
if (ar[i] == ar[i + 1])
count++;
else
break ;
}
res = max(res, count);
}
return res;
}
int main()
{
int arr[] = { 5, 6, 9, 3, 4, 3, 4 };
int n = sizeof (arr) / sizeof (arr[0]);
cout << subset(arr, n);
return 0;
}
|
Java
import java.util.*;
import java.lang.*;
public class GfG{
public static int subset( int ar[], int n)
{
int res = 0 ;
Arrays.sort(ar);
for ( int i = 0 ; i < n; i++) {
int count = 1 ;
for (; i < n - 1 ; i++) {
if (ar[i] == ar[i + 1 ])
count++;
else
break ;
}
res = Math.max(res, count);
}
return res;
}
public static void main(String argc[])
{
int arr[] = { 5 , 6 , 9 , 3 , 4 , 3 , 4 };
int n = 7 ;
System.out.println(subset(arr, n));
}
}
|
Python3
def subset(ar, n):
res = 0
ar.sort()
for i in range ( 0 , n) :
count = 1
for i in range (n - 1 ):
if ar[i] = = ar[i + 1 ]:
count + = 1
else :
break
res = max (res, count)
return res
ar = [ 5 , 6 , 9 , 3 , 4 , 3 , 4 ]
n = len (ar)
print (subset(ar, n))
|
C#
using System;
public class GfG {
public static int subset( int []ar, int n)
{
int res = 0;
Array.Sort(ar);
for ( int i = 0; i < n; i++) {
int count = 1;
for ( ; i < n - 1; i++) {
if (ar[i] == ar[i + 1])
count++;
else
break ;
}
res = Math.Max(res, count);
}
return res;
}
public static void Main()
{
int []arr = { 5, 6, 9, 3, 4, 3, 4 };
int n = 7;
Console.WriteLine(subset(arr, n));
}
}
|
Javascript
<script>
function subset(ar, n)
{
let res = 0;
ar.sort();
for (let i = 0; i < n; i++)
{
let count = 1;
for (; i < n - 1; i++)
{
if (ar[i] == ar[i + 1])
count++;
else
break ;
}
res = Math.max(res, count);
}
return res;
}
let arr = [ 5, 6, 9, 3, 4, 3, 4 ];
let n = 7;
document.write(subset(arr, n));
</script>
|
PHP
<?php
function subset( $ar , $n )
{
$res = 0;
sort( $ar );
for ( $i = 0; $i < $n ; $i ++)
{
$count = 1;
for (; $i < $n - 1; $i ++)
{
if ( $ar [ $i ] == $ar [ $i + 1])
$count ++;
else
break ;
}
$res = max( $res , $count );
}
return $res ;
}
$arr = array ( 5, 6, 9, 3, 4, 3, 4 );
$n = sizeof( $arr );
echo subset( $arr , $n );
?>
|
Time Complexity: O(n2)
Auxiliary Space: O(1)
An efficient solution is to use hashing. We count frequencies of all elements in a hash table. Finally we return the key with maximum value in hash table.
Implementation:
C++
#include <bits/stdc++.h>
using namespace std;
int subset( int arr[], int n)
{
unordered_map< int , int > mp;
for ( int i = 0; i < n; i++)
mp[arr[i]]++;
int res = 0;
for ( auto x : mp)
res = max(res, x.second);
return res;
}
int main()
{
int arr[] = { 5, 6, 9, 3, 4, 3, 4 };
int n = sizeof (arr) / sizeof (arr[0]);
cout << subset(arr, n);
return 0;
}
|
Java
import java.util.HashMap;
import java.util.Map;
class GFG
{
static int subset( int arr[], int n)
{
HashMap<Integer, Integer> mp = new HashMap<>();
for ( int i = 0 ; i < n; i++)
mp.put(arr[i],mp.get(arr[i]) == null ? 1 :mp.get(arr[i])+ 1 );
int res = 0 ;
for (Map.Entry<Integer,Integer> entry : mp.entrySet())
res = Math.max(res, entry.getValue());
return res;
}
public static void main(String[] args)
{
int arr[] = { 5 , 6 , 9 , 3 , 4 , 3 , 4 };
int n = arr.length;
System.out.println( subset(arr, n));
}
}
|
Python3
def subset(arr, n):
mp = {i: 0 for i in range ( 10 )}
for i in range (n):
mp[arr[i]] + = 1
res = 0
for key, value in mp.items():
res = max (res, value)
return res
if __name__ = = '__main__' :
arr = [ 5 , 6 , 9 , 3 , 4 , 3 , 4 ]
n = len (arr)
print (subset(arr, n))
|
C#
using System;
using System.Collections.Generic;
class GFG
{
static int subset( int []arr, int n)
{
Dictionary< int ,
int > mp = new Dictionary< int ,
int >();
for ( int i = 0 ; i < n; i++)
{
if (mp.ContainsKey(arr[i]))
{
var val = mp[arr[i]];
mp.Remove(arr[i]);
mp.Add(arr[i], val + 1);
}
else
{
mp.Add(arr[i], 1);
}
}
int res = 0;
foreach (KeyValuePair< int , int > entry in mp)
res = Math.Max(res, entry.Value);
return res;
}
public static void Main(String[] args)
{
int []arr = { 5, 6, 9, 3, 4, 3, 4 };
int n = arr.Length;
Console.WriteLine(subset(arr, n));
}
}
|
Javascript
<script>
function subset(arr, n) {
var mp = {};
for ( var i = 0; i < n; i++) {
if (mp.hasOwnProperty(arr[i])) {
var val = mp[arr[i]];
delete mp[arr[i]];
mp[arr[i]] = val + 1;
} else {
mp[arr[i]] = 1;
}
}
var res = 0;
for (const [key, value] of Object.entries(mp)) {
res = Math.max(res, value);
}
return res;
}
var arr = [5, 6, 9, 3, 4, 3, 4];
var n = arr.length;
document.write(subset(arr, n));
</script>
|
Time Complexity: O(n)
Auxiliary Space: O(n)
Example in c:
Approach:
Initialize a hash set to store distinct elements and a variable, count, to zero.
Iterate over all elements of the array.
For each element, check if it is already present in the hash set using the following conditions:
If the element is not present, add it to the hash set.
If the element is present, increment the count and reset the hash set.
Finally, return the count.
C++
#include <iostream>
using namespace std;
struct node {
int data;
struct node* next;
};
struct node* create_node( int data) {
struct node* new_node = ( struct node*) malloc ( sizeof ( struct node));
new_node->data = data;
new_node->next = NULL;
return new_node;
}
struct set {
struct node* head;
};
struct set* create_set() {
struct set* new_set = ( struct set*) malloc ( sizeof ( struct set));
new_set->head = NULL;
return new_set;
}
void add_to_set( struct set* set, int data) {
if (set->head == NULL) {
set->head = create_node(data);
return ;
}
struct node* current = set->head;
while (current != NULL) {
if (current->data == data) {
return ;
}
current = current->next;
}
struct node* new_node = create_node(data);
new_node->next = set->head;
set->head = new_node;
}
void delete_set( struct set* set) {
struct node* current = set->head;
while (current != NULL) {
struct node* temp = current;
current = current->next;
free (temp);
}
free (set);
}
int count_min_subsets_with_distinct_elements( int arr[], int n) {
struct set* set = create_set();
int count = 0;
for ( int i = 0; i < n; i++) {
if (set->head == NULL || !(set, arr[i])) {
add_to_set(set, arr[i]);
} else {
count++;
delete_set(set);
set = create_set();
add_to_set(set, arr[i]);
}
}
delete_set(set);
if (count == 0) {
return 1;
} else {
return count + 1;
}
}
int main() {
int arr[] = {1, 2, 3, 1, 2, 3, 4, 5};
int n = sizeof (arr) / sizeof (arr[0]);
cout << "Minimum number of subsets with distinct elements: " << count_min_subsets_with_distinct_elements(arr, n) << endl;
return 0;
}
|
C
#include <stdio.h>
#include <stdlib.h>
struct node {
int data;
struct node *next;
};
struct node* create_node( int data) {
struct node* new_node = ( struct node*) malloc ( sizeof ( struct node));
new_node->data = data;
new_node->next = NULL;
return new_node;
}
struct set {
struct node *head;
};
struct set* create_set() {
struct set* new_set = ( struct set*) malloc ( sizeof ( struct set));
new_set->head = NULL;
return new_set;
}
void add_to_set( struct set *set, int data) {
if (set->head == NULL) {
set->head = create_node(data);
return ;
}
struct node *current = set->head;
while (current != NULL) {
if (current->data == data) {
return ;
}
current = current->next;
}
struct node *new_node = create_node(data);
new_node->next = set->head;
set->head = new_node;
}
void delete_set( struct set *set) {
struct node *current = set->head;
while (current != NULL) {
struct node *temp = current;
current = current->next;
free (temp);
}
free (set);
}
int count_min_subsets_with_distinct_elements( int arr[], int n) {
struct set *set = create_set();
int count = 0;
for ( int i = 0; i < n; i++) {
if (set->head == NULL || !(set, arr[i])) {
add_to_set(set, arr[i]);
} else {
count++;
delete_set(set);
set = create_set();
add_to_set(set, arr[i]);
}
}
delete_set(set);
if (count == 0) {
return 1;
} else {
return count + 1;
}
}
int main() {
int arr[] = {1, 2, 3, 1, 2, 3, 4, 5};
int n = sizeof (arr) / sizeof (arr[0]);
printf ( "Minimum number of subsets with distinct elements: %d\n" , count_min_subsets_with_distinct_elements(arr, n));
return 0;
}
|
Java
import java.util.HashSet;
import java.util.Set;
public class Main {
public static int
minSubsetsWithDistinctElements( int [] arr)
{
Set<Integer> uniqueElements = new HashSet<>();
int count = 0 ;
for ( int i = 0 ; i < arr.length; i++) {
if (!uniqueElements.contains(arr[i])) {
uniqueElements.add(arr[i]);
}
else {
count += uniqueElements.size();
uniqueElements.clear();
uniqueElements.add(arr[i]);
}
}
return count + uniqueElements.size();
}
public static void main(String[] args)
{
int [] arr = { 1 , 2 , 3 , 1 , 2 , 3 , 4 , 5 };
int result = minSubsetsWithDistinctElements(arr);
System.out.println(
"Minimum number of subsets with distinct elements: "
+ result);
}
}
|
Python
def min_subsets_with_distinct_elements(arr):
unique_elements = set ()
count = 0
for element in arr:
if element not in unique_elements:
unique_elements.add(element)
else :
count + = len (unique_elements)
unique_elements.clear()
unique_elements.add(element)
return count + len (unique_elements)
if __name__ = = "__main__" :
arr = [ 1 , 2 , 3 , 1 , 2 , 3 , 4 , 5 ]
result = min_subsets_with_distinct_elements(arr)
print ( "Minimum number of subsets with distinct elements:" , result)
|
C#
using System;
public class Program {
public class Node {
public int data;
public Node next;
}
public static Node create_node( int data) {
Node new_node = new Node();
new_node.data = data;
new_node.next = null ;
return new_node;
}
public class Set {
public Node head;
}
public static Set create_set() {
Set new_set = new Set();
new_set.head = null ;
return new_set;
}
public static void add_to_set(Set set , int data) {
if ( set .head == null ) {
set .head = create_node(data);
return ;
}
Node current = set .head;
while (current != null ) {
if (current.data == data) {
return ;
}
current = current.next;
}
Node new_node = create_node(data);
new_node.next = set .head;
set .head = new_node;
}
public static void delete_set(Set set ) {
Node current = set .head;
while (current != null ) {
Node temp = current;
current = current.next;
temp = null ;
}
set .head = null ;
}
public static int count_min_subsets_with_distinct_elements( int [] arr, int n) {
Set set = create_set();
int count = 0;
for ( int i = 0; i < n; i++) {
if ( set .head == null || !set_has( set , arr[i])) {
add_to_set( set , arr[i]);
} else {
count++;
delete_set( set );
set = create_set();
add_to_set( set , arr[i]);
}
}
delete_set( set );
if (count == 0) {
return 1;
} else {
return count + 1;
}
}
public static bool set_has(Set set , int data) {
Node current = set .head;
while (current != null ) {
if (current.data == data) {
return true ;
}
current = current.next;
}
return false ;
}
public static void Main() {
int [] arr = {1, 2, 3, 1, 2, 3, 4, 5};
int n = arr.Length;
Console.WriteLine( "Minimum number of subsets with distinct elements: " + count_min_subsets_with_distinct_elements(arr, n));
}
}
|
Javascript
function GFG(arr) {
let uniqueElements = new Set();
let count = 0;
for (let i = 0; i < arr.length; i++) {
if (!uniqueElements.has(arr[i])) {
uniqueElements.add(arr[i]);
} else {
count += uniqueElements.size;
uniqueElements.clear();
uniqueElements.add(arr[i]);
}
}
return count + uniqueElements.size;
}
const arr = [1, 2, 3, 1, 2, 3, 4, 5];
const result = GFG(arr);
console.log( "Minimum number of subsets with distinct elements:" , result);
|
Output
Minimum number of subsets with distinct elements: 8
The time complexity of this approach is O(n^2) since we use a loop within a loop to check for distinct elements.
The space complexity is O(n) since we use a hash set to store distinct elements.
Approach:
At first, Initialize a DP array of size n, where n is the length of the input array. Now, we know dp[i] represents the minimum number of subsets required up to the i-th element of the given array.
Initialize a set to keep track of distinct elements seen so far. This set will be used to check for duplicate elements.
Initialize dp[0] as 1, since the first element itself forms a subset. Iterate through the array starting from the second element (i = 1) to the last element (i = n-1):Check if the current element is already present in the set.
If it is not present, add it to the set and set dp[i] = dp[i-1].
If it is present, increment dp[i] by 1 to account for a new subset required.
Clear the set and add the current element to start a new subset.
The final answer will be dp[n-1], representing the minimum number of subsets required to cover all the distinct elements.
C++
#include <iostream>
#include <unordered_set>
using namespace std;
int GFG( int arr[], int n) {
int dp[n];
unordered_set< int > distinctElements;
dp[0] = 1;
distinctElements.insert(arr[0]);
for ( int i = 1; i < n; i++) {
if (distinctElements.find(arr[i]) == distinctElements.end()) {
distinctElements.insert(arr[i]);
dp[i] = dp[i - 1];
} else {
dp[i] = dp[i - 1] + 1;
distinctElements.clear();
distinctElements.insert(arr[i]);
}
}
return dp[n - 1];
}
int main() {
int arr[] = {1, 2, 3, 4};
int n = sizeof (arr) / sizeof (arr[0]);
int minSubsets = GFG(arr, n);
cout << "Minimum number of subsets: " << minSubsets << endl;
int arr2[] = {1, 2, 3, 3};
int n2 = sizeof (arr2) / sizeof (arr2[0]);
minSubsets = GFG(arr2, n2);
cout << "Minimum number of subsets: " << minSubsets << endl;
return 0;
}
|
Java
import java.io.*;
import java.util.HashSet;
import java.util.Set;
class GFG {
public static int minSubsetsDistinctElements( int [] arr) {
int n = arr.length;
int [] dp = new int [n];
Set<Integer> distinctElements = new HashSet<>();
dp[ 0 ] = 1 ;
distinctElements.add(arr[ 0 ]);
for ( int i = 1 ; i < n; i++) {
if (!distinctElements.contains(arr[i])) {
distinctElements.add(arr[i]);
dp[i] = dp[i - 1 ];
} else {
dp[i] = dp[i - 1 ] + 1 ;
distinctElements.clear();
distinctElements.add(arr[i]);
}
}
return dp[n - 1 ];
}
public static void main(String[] args) {
int [] arr = { 1 , 2 , 3 , 4 };
int minSubsets = minSubsetsDistinctElements(arr);
System.out.println( "Minimum number of subsets: " + minSubsets);
arr = new int []{ 1 , 2 , 3 , 3 };
minSubsets = minSubsetsDistinctElements(arr);
System.out.println( "Minimum number of subsets: " + minSubsets);
}
}
|
Python3
def minSubsetsDistinctElements(arr):
n = len (arr)
dp = [ 0 ] * n
distinctElements = set ()
dp[ 0 ] = 1
distinctElements.add(arr[ 0 ])
for i in range ( 1 , n):
if arr[i] not in distinctElements:
distinctElements.add(arr[i])
dp[i] = dp[i - 1 ]
else :
dp[i] = dp[i - 1 ] + 1
distinctElements.clear()
distinctElements.add(arr[i])
return dp[n - 1 ]
if __name__ = = "__main__" :
arr = [ 1 , 2 , 3 , 4 ]
minSubsets = minSubsetsDistinctElements(arr)
print ( "Minimum number of subsets:" , minSubsets)
arr = [ 1 , 2 , 3 , 3 ]
minSubsets = minSubsetsDistinctElements(arr)
print ( "Minimum number of subsets:" , minSubsets)
|
C#
using System;
using System.Collections.Generic;
class Program {
static int GFG( int [] arr, int n)
{
int [] dp = new int [n];
HashSet< int > distinctElements = new HashSet< int >();
dp[0] = 1;
distinctElements.Add(arr[0]);
for ( int i = 1; i < n; i++) {
if (!distinctElements.Contains(arr[i])) {
distinctElements.Add(arr[i]);
dp[i] = dp[i - 1];
}
else {
dp[i] = dp[i - 1] + 1;
distinctElements.Clear();
distinctElements.Add(arr[i]);
}
}
return dp[n - 1];
}
static void Main()
{
int [] arr = { 1, 2, 3, 4 };
int n = arr.Length;
int minSubsets = GFG(arr, n);
Console.WriteLine( "Minimum number of subsets: "
+ minSubsets);
int [] arr2 = { 1, 2, 3, 3 };
int n2 = arr2.Length;
minSubsets = GFG(arr2, n2);
Console.WriteLine( "Minimum number of subsets: "
+ minSubsets);
}
}
|
Javascript
function minSubsetsDistinctElements(arr) {
const n = arr.length;
const dp = new Array(n);
const distinctElements = new Set();
dp[0] = 1;
distinctElements.add(arr[0]);
for (let i = 1; i < n; i++) {
if (!distinctElements.has(arr[i])) {
distinctElements.add(arr[i]);
dp[i] = dp[i - 1];
} else {
dp[i] = dp[i - 1] + 1;
distinctElements.clear();
distinctElements.add(arr[i]);
}
}
return dp[n - 1];
}
const arr1 = [1, 2, 3, 4];
const minSubsets1 = minSubsetsDistinctElements(arr1);
console.log( "Minimum number of subsets:" , minSubsets1);
const arr2 = [1, 2, 3, 3];
const minSubsets2 = minSubsetsDistinctElements(arr2);
console.log( "Minimum number of subsets:" , minSubsets2);
|
Output
Minimum number of subsets: 1
Minimum number of subsets: 2
Time complexity : O(n), where n is the size of the input array.
Auxiliary Space: O(n) as we have used the DP array to store intermediate results.
Please Login to comment...